<?php
/**
 *   @copyright Copyright (c) 2011 Quality Unit s.r.o.
 *   @author Juraj Simon
 *   @package WpPostAffiliateProPlugin
 *   @since version 1.0.0
 *
 *   Licensed under GPL2
 */

class postaffiliatepro_Form_Settings_General extends postaffiliatepro_Form_Base {
    public function __construct() {
        parent::__construct(postaffiliatepro::GENERAL_SETTINGS_PAGE_NAME, 'options.php');
    }

    protected function getTemplateFile() {
        return WP_PLUGIN_DIR . '/postaffiliatepro/Template/GeneralSettings.xtpl';
    }

    protected function getType() {
        return postaffiliatepro_Form_Base::TYPE_FORM;
    }

    protected function initForm() {
        $url = get_option(postaffiliatepro::PAP_URL_SETTING_NAME);
        if (empty($url)) {
            $this->addTextBox(postaffiliatepro::PAP_URL_SETTING_NAME, 50);
        } else {
            if (substr($url, -1) != '/') {
                $url .= '/';
            }
            $this->addTextBox(postaffiliatepro::PAP_URL_SETTING_NAME, 50, $url, true);
        }

        $this->addTextBox(postaffiliatepro::PAP_MERCHANT_NAME_SETTING_NAME, 30);
        $this->addPassword(postaffiliatepro::PAP_MERCHANT_PASSWORD_SETTING_NAME, 30);
        $this->addTextBox(postaffiliatepro::CLICK_TRACKING_ACCOUNT_SETTING_NAME, 30, 'default1');
        $this->checkCredentails();
        $this->addSubmit();
    }

    private function checkCredentails() {
        $session = $this->getApiSession();
        if ($session !== null) {
            $this->parseBlock('login_check_ok', array());
            $this->parseBlock('installation_info', array('pap-version' => $this->getPapVersion()));
        } else {
            $this->parseBlock('login_check_failed', array());
        }
    }
}
